/*
 * Copyright
 *   2007 axYus - www.axyus.com
 *   2005 C.Marchand - christophe.marchand@axyus.com
 *
 * This file is part of XEMELIOS.
 *
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package fr.gouv.finances.cp.xemelios.common.config;

import java.util.Enumeration;
import java.util.Hashtable;

import org.xml.sax.SAXException;

import fr.gouv.finances.cp.utils.xml.marshal.InvalidXmlDefinition;
import fr.gouv.finances.cp.utils.xml.marshal.XmlAttributes;
import fr.gouv.finances.cp.utils.xml.marshal.XmlMarshallable;
import fr.gouv.finances.cp.utils.xml.marshal.XmlOutputter;

/**
 * @author chm
 * @deprecated
 */
public class CopyModel implements XmlMarshallable {
    public static final transient String TAG = "copy";
    private String tag;
    private Hashtable<String,PathModel> paths;
    private Hashtable<String,TransformModel> transforms;

    /**
     * 
     */
    public CopyModel(String tagName) {
        super();
        paths = new Hashtable<String,PathModel>();
        transforms = new Hashtable<String,TransformModel>();
    }

    public void addCharacterData(String cData) throws SAXException {}

    public void addChild(XmlMarshallable child, String tagName) throws SAXException {
        if(PathModel.TAG.equals(tagName)) {
            PathModel pm = (PathModel)child;
            paths.put(pm.getName(),pm);
        } else if(TransformModel.TAG.equals(tagName)) {
            TransformModel tm = (TransformModel)child;
            transforms.put(tm.getAttr(),tm);
        }
    }

    public XmlMarshallable getAttributes(XmlAttributes attributes) throws SAXException {
        tag = attributes.getValue("tag-name");
        return this;
    }

    public void marshall(XmlOutputter output) {throw new Error("Not yet implemented"); }

    public void validate() throws InvalidXmlDefinition {}

    @Override
    public boolean equals(Object o) {
        if(o==this) return true;
        if(o instanceof String) return tag.equals(o);
        if(o instanceof CopyModel) {
            CopyModel other = (CopyModel)o;
            return other.getTag().equals(tag);
        }
        return false;
    }
    @Override
    public CopyModel clone() {
        CopyModel cm = new CopyModel(TAG);
        cm.tag = this.tag;
        for(Enumeration<String> enumer=paths.keys();enumer.hasMoreElements();) {
            String key = enumer.nextElement();
            PathModel pm = paths.get(key);
            cm.paths.put(key,pm);
        }
        for(Enumeration<String> enumer=transforms.keys();enumer.hasMoreElements();) {
            String key = enumer.nextElement();
            TransformModel tm = transforms.get(key);
            cm.transforms.put(key,tm);
        }
        return cm;
    }
    public String getTag() { return tag; }
    public PathModel getPath(String path) {
        return paths.get(path);
    }
    public TransformModel getTransform(String attName) {
        return transforms.get(attName);
    }
    
}
